<template>
  <div>
    <div class="row mt-5">
      <div class="col-md-12">
        <div class="card">
          <div class="card-header">
            <h3 class="card-title">Transactions components categories</h3>

            <div class="card-tools">
              <button class="btn btn-success" @click="newModal">
                Add New
                <i class="fas fa-plus fa-fw"></i>
              </button>
            </div>
          </div>
          <!-- /.card-header -->
          <div class="card-body table-responsive p-0">
            <table class="table table-hover">
              <tbody>
                <tr>
                  <th>Category name</th>
                </tr>
                <tr v-for="category in categories.data" :key="category.id">
                  <td>{{category.name}}</td>
                  <td>
                    <a href="#" @click="editModal(category)">
                      <i class="fa fa-edit blue"></i>
                    </a>
                    /
                    <a href="#" @click="deleteCategory(category.id)">
                      <i class="fa fa-trash red"></i>
                    </a>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>

          <!-- /.card-body -->
          <div class="card-footer">
            <pagination :data="categories" @pagination-change-page="getResults"></pagination>
          </div>
        </div>
        <!-- /.card -->
      </div>

      <div v-if="categories.data && categories.data.length > 0" class="col-md-12">
        <div class="card">
          <div class="card-header">
            <h3 class="card-title">Sort categories by priority</h3>
          </div>
          <!-- /.card-header -->
          <div class="card-body categories-sort-list">
            <ul class="list-group mb-2">
              <draggable v-model="sortedCategories">
                <transition-group>
                  <li
                    class="list-group-item"
                    v-for="cat in sortedCategories"
                    :key="cat.id"
                    v-text="cat.name"
                  ></li>
                </transition-group>
              </draggable>
            </ul>
          </div>
          <div class="card-footer">
            <button
              type="submit"
              class="btn btn-success"
              @click="submitSortedCategories()"
            >Submit sequence</button>
          </div>
        </div>
      </div>
    </div>

    <!-- Modal -->
    <div
      class="modal fade"
      id="addNew"
      tabindex="-1"
      role="dialog"
      aria-labelledby="addNewLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" v-show="!editmode" id="addNewLabel">Add New</h5>
            <h5
              class="modal-title"
              v-show="editmode"
              id="addNewLabel"
            >Update Transactions Category's Info</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <form @submit.prevent="editmode ? updateCategory() : createCategory()">
            <div class="modal-body">
              <div class="form-group">
                <label for="category">Category name</label>
                <input
                  id="category"
                  v-model="form.name"
                  type="text"
                  name="category"
                  placeholder="Category name"
                  class="form-control"
                  :class="{ 'is-invalid': form.errors.has('name') }"
                />
                <has-error :form="form" field="name"></has-error>
              </div>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
              <button v-show="editmode" type="submit" class="btn btn-success">Update</button>
              <button v-show="!editmode" type="submit" class="btn btn-success">Create</button>
            </div>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import moment from "moment";
import draggable from "vuedraggable";

export default {
  components: {
    draggable
  },
  data() {
    return {
      editmode: false,
      categories: {},
      sortedCategories: [],
      form: new Form({
        name: "",
        id: ""
      })
    };
  },
  methods: {
    submitSortedCategories() {
      this.$Progress.start();
      let postData = this.sortedCategories.map(category => {
        return {
          id: category.id
        };
      });

      axios
        .post("/api/sort-categories", {
          sortedCategories: postData
        })
        .then(() => {
          this.$Progress.finish();
           toast({
            type: "success",
            title: "Categories sorted successfuly!"
          });
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
        });
    },
    getResults(page = 1) {
      axios
        .get("api/component-category?paginate=1", {
          params: {
            page: page
          }
        })
        .then(response => {
          this.categories = response.data;
        });
    },
    updateCategory() {
      this.$Progress.start();
      this.form
        .put("api/component-category/" + this.form.id)
        .then(() => {
          // success
          $("#addNew").modal("hide");
          swal("Updated!", "Information has been updated.", "success");
          this.$Progress.finish();
          this.loadCategories();
        })
        .catch(() => {
          this.$Progress.fail();
        });
    },
    editModal(category) {
      this.editmode = true;
      this.form.reset();
      this.form.fill(category);
      $("#addNew").modal("show");
    },
    newModal() {
      this.editmode = false;
      this.form.reset();
      $("#addNew").modal("show");
    },
    deleteCategory(id) {
      swal({
        title: "Are you sure?",
        text: "You won't be able to revert this!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes, delete it!"
      }).then(result => {

        if (result.value) {
          this.form
            .delete("api/component-category/" + id)
            .then(() => {
              swal(
                "Deleted!",
                "Your transaction category has been deleted.",
                "success"
              );
              this.loadCategories();
            })
            .catch(error => {
              swal(
                "Failed!",
                "Cannot delete category which has transactions",
                "warning"
              );
            });
        }
      });
    },
    loadCategories() {
      axios.get("api/component-category?paginate=1").then(response => {
        this.categories = response.data;
      });

      axios.get("api/component-category?paginate=0").then(response => {
        this.sortedCategories = response.data;
      });
    },

    createCategory() {
      this.$Progress.start();

      this.form
        .post("api/component-category")
        .then(() => {
           this.loadCategories();
          $("#addNew").modal("hide");

          toast({
            type: "success",
            title: "Transaction category Created in successfully"
          });
          this.$Progress.finish();
        })
        .catch(() => {});
    }
  },
  created() {
    this.loadCategories();
  }
};
</script>

<style lang="css">
.mx-datepicker-popup {
  z-index: 50000000000000 !important;
}
</style>
